REM IMPIANTO MOTORE CON TURBINA A GAS CON RISCALDAMENTO RIPETUTO
REM Gas utilizzato -> ARIA considerato come gas PERFETTO
REM Proprieta' gas -> pv=RT, cp=a+bT+cT^2+dT^3, cp-cv=R
REM
REM
REM STATO DI RIFERIMENTO:
REM          Trif=293 K,prif=1.01 bar,hrif=293 kJ/kg,srif=1.678 kJ/kgK
REM
REM DELTAh = a*(T-Trif)+ b/2*(T^2-Trif^2)+ c/3*(T^3-Trif^3)+ d/4*(T^4-Trif^4)
REM DELTAs=a*LOG(T/Trif)+ b*(T-Trif)+ c/2*(T^2-Trif^2)+ d/3*(T^3-Trif^3)- R*LOG(p/prif)
REM
REM R=0.28713 kJ/(kgK);a=1.048;b=-3.837*10-4;c=9.453*10-7;d=-5.490*10-10
REM ADIABATICA+INT.REV. pv^k=cost; t/(p^((k-1)/k)=cost;
REM                     l=(p1v1)/(k-1)[1-(p2/p1)^((k-1)/k)]
REM                     k=1.4: (k-1)/k= gamma= 0.2857
REM STATO AMBIENTE: pamb= 1.01 bar, hamb-Tamb*samb = Costex
REM ricordiamo che per ciclo reale:
REM                                 beta=(Pmax/Pint)*(Pint/Pmin)
REM                                 Lu_max se e' Pint=Pmin*(beta)^(1/2)
REM ricordiamo che
REM   per il comp--> h2-h1=(h2-h2s)/(1-eta); se T>Tamb --> eta_ex > eta
REM   per la turb--> h1-h2s=(h2-h2s)/(1-eta); se T>Tamb --> eta_ex > eta
REM
REM ****DICHIARAZIONI SOTTOPROGRAMMI****
    DECLARE SUB newtonDs (t1tent!, tiniz!, p1, p2, co, tusc!)
    DECLARE SUB newtonDh (t1tent!, tiniz!, h1, h2, co, tusc!)
    DECLARE SUB sccalore (t2!, Tset!, pingr, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
    DECLARE SUB turbina (ting!, ping!, pusc!, ingt, rend!, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
    DECLARE SUB pott (eta1ap, eta1bp, eta2, TA, tmax, tmin, beta, pmin, mak(), Ptot, risul, pot, COMPON(), TEMP(), PRES(), ENTR(), ENTAL(), EXER())
REM
REM ****DICHIARAZIONE VETTORI E MATRICI AUSILARI***
REM VETTORI PROPRIETA' PUNTI
    DIM TEMP(7): DIM PRES(7): DIM ENTAL(7): DIM ENTR(7): DIM EXER(7)
REM MATRICE PROPRIETA' COMPONENTI
    DIM COMPON(6, 7)
    DIM mak(2, 50)
REM [rendim., delta, rend. ex., exdis, sgen, cal_sc., Ltot]
REM Compr.=comp. 1, SetA_1=2, Turb._ap=3, SetA_2=4, Turb.bp=5, SetB=6
REM
REM ****DICHIARAZIONE MATRICI DI SALVATAGGIO VALORI****
    DIM COMP2(6, 7): DIM PROP(5, 6)
REM
REM ****DICHIARAZIONE COSTANTI****
REM COSTANTI COMUNI
    COMMON SHARED a, B, c, d, R, k, cp, gamma, trif, hrif, srif, tamb, pamb, cnck, eps, Costex, beta
1   REM
    a = 1.048
    B = -.0003837
    c = 9.453E-07
    d = -5.49E-10
    R = .28713
    k = 1.4
    cp = 1.01
    gamma = .2857
    trif = 293!
    pamb = 1.01
    hrif = 293!
    srif = 1.678
    cnck = 273.15
    eps = .0001
REM Attenzione la costante exergetica Costex dipende dalla temperatura ambiente
REM quindi il suo calcolo  rimandato all'acquisizione dei dati sullo stato ambiente
   IF st = 4 THEN GOTO 2
REM
REM ****FUNZIONI AUSILIARIE****
    DEF FNEntr (x, y, px, py) = a * LOG(x / y) + B * (x - y) + c / 2 * (x ^ 2 - y ^ 2) + d / 3 * (x ^ 3 - y ^ 3) - R * LOG(px / py)
    DEF FNEntal (x, y) = a * (x - y) + B / 2 * (x ^ 2 - y ^ 2) + c / 3 * (x ^ 3 - y ^ 3) + d / 4 * (x ^ 4 - y ^ 4)
REM
REM ****SCHERMATA INIZIALE CON PRESENTAZIONE STUDENTI****
    SCREEN 11
    PALETTE 0, 2097152
REM ****Strauss, Cos parl Zarathrustra****
    st$ = "T100 O3 C2 G2 O4 C2.. E4  E-2."
    st2$ = "p16 o1 L8 GDGDGD"
    PLAY "MB" + st$ + st2$
    FOR i = 1 TO 240
        CIRCLE (320, 240), i
        CIRCLE (320, 240), 240 - i
        CLS
    NEXT i
    FOR i = 1 TO 160
        LINE (320 - i, 240 - i)-(320 + i, 240 + i), , B
    NEXT i
    CLS
    LINE (40, 60)-(580, 440), , B
    LOCATE 5, 20: PRINT "CICLO JOULE CON RISCALDAMENTO RIPETUTO"
    LOCATE 24, 8: PRINT "VERSIONE MODIFICATA PER IL SALVATAGGIO DEI DATI"
    LOCATE 25, 8: PRINT "Renato M. Buontempo  43/1209"
    LOCATE 26, 8: PRINT "Antonio Cianciulli   43/0646"
    LOCATE 27, 8: PRINT "Assunta Napolitano   43/2057"
    LOCATE 29, 25: PRINT "Premere un tasto per continuare"
    DRAW "BM 200,240 M+0,-40 M+10,10 M+0,20 M-10,10"
    DRAW "BM 210,210 M+0,-40 M+30,0 M+10,-10 M+20,20 M+10,-10 M+30,0"
    DRAW "BM 310,170 M+0,40 M+0,20 M+10,10 M+0,-40 M-10,10"
    DRAW "BM 320,200 M+0,-30 M+30,0 M+10,-10 M+20,20 M+10,-10 M+30,0"
    DRAW "BM 420,170 M+0,40 M+0,20 M+10,10 M+0,-40 M-10,10"
    DRAW "BM 430,240 M+0,30 M-95,0 M-10,10 M-20,-20 M-10,10 M-95,0 M+0,-30"
    DRAW "BM 210,223 M+100,0 BM 210,217 M+100,0"
    DRAW "BM 320,223 M+100,0 BM 320,217 M+100,0"
    DRAW "BM 430,223 M+15,0 BM 430,217 M+15,0"
    CIRCLE (460, 220), 15
    LINE (235, 155)-(285, 185), , B: LINE (345, 155)-(395, 185), , B
    LINE (290, 255)-(340, 285), , B
    DRAW "BM 207,190 M+6,0 BM 307,190 M+6,0 BM 317,190 M+6,0 BM 417,190 M+6,0"
    DRAW "BM 197,260 M+6,0 BM 427,260 M+6,0"
    LOCATE 17, 24: PRINT "1": LOCATE 12, 25: PRINT "2"
    LOCATE 12, 38: PRINT "3": LOCATE 12, 42: PRINT "4"
    LOCATE 12, 55: PRINT "5": LOCATE 17, 56: PRINT "6"
    WHILE INKEY$ = "": WEND
REM ****ACQUISIZIONE DATI STATO AMBIENTE****
2   y$ = "n"
    WHILE UCASE$(y$) = "N" OR tamb < 0 OR tamb > 20
        CLS
        LINE (30, 30)-(580, 230), , B
        LOCATE 3, 33: PRINT "STATO AMBIENTE"
        LOCATE 5, 7: INPUT "Temperatura (C) [compresa tra 0 e 20 C]"; tamb
        LOCATE 7, 7: PRINT "La pressione ambiente  per default impostata a 1,01 bar"
        LOCATE 12, 30: PRINT "Dati esatti (s/n)  s"
        LOCATE 12, 49: INPUT y$
    WEND
REM ****ACQUISIZIONE DATI DEL CICLO****
REM RENDIMENTI
    y$ = "N"
    WHILE UCASE$(y$) = "N" OR test1 = 0 OR test2 = 0 OR test3 = 0
        CLS
        test1 = 1: test2 = 1: test3 = 1
        LINE (30, 30)-(580, 330), , B
        LOCATE 3, 35: PRINT "RENDIMENTI"
        LOCATE 5, 7: INPUT "Rendimento turbina alta press. [90<=ETAis<=95] (%)"; eta1ap
        IF eta1ap < 90 OR eta1ap > 95 THEN test1 = 0
        LOCATE 7, 7: INPUT "Rendimento turbina bassa press. [90<=ETAis<=95] (%)"; eta1bp
        IF eta1bp < 90 OR eta1bp > 95 THEN test2 = 0
        LOCATE 9, 7: INPUT "Rendimento compressore [85<=ETAis<=90] (%)"; eta2
        IF eta2 < 85 OR eta2 > 90 THEN test3 = 0
        LOCATE 17, 30: PRINT "Dati esatti (s/n)  s"
        LOCATE 17, 49: INPUT y$
    WEND
REM TEMPERATURE
    y$ = "N"
    WHILE UCASE$(y$) = "N" OR test1 = 0 OR test2 = 0 OR test3 = 0
        CLS
        test1 = 1: test2 = 1: test3 = 1
        LINE (30, 30)-(580, 330), , B
        LOCATE 3, 35: PRINT "TEMPERATURE"
        LOCATE 5, 7: INPUT "Temperatura SET superiore [1200<=SETa<=1400] (C)"; TA
        IF TA < 1200 OR TA > 1400 THEN test1 = 0
        LOCATE 7, 7: INPUT "Temperatura max del ciclo [800<=Tmax<=1100] (C)"; tmax
        IF tmax < 800 OR tmax > 1100 THEN test2 = 0
        LOCATE 9, 7: INPUT "Temperatura min del ciclo [Tmin>=Tamb] (C)"; tmin
        IF tmin < tamb THEN test3 = 0
        LOCATE 17, 30: PRINT "Dati esatti (s/n)  s"
        LOCATE 17, 49: INPUT y$
    WEND
REM PRESSIONI E POTENZA UTILE
    y$ = "N"
    WHILE UCASE$(y$) = "N" OR test1 = 0 OR test2 = 0 OR test3 = 0 OR test4 = 0
        CLS
        test1 = 1: test2 = 1: test3 = 1: test4 = 1
        LINE (30, 30)-(580, 330), , B
        LOCATE 3, 27: PRINT "PRESSIONI E POTENZA UTILE"
        LOCATE 5, 7: INPUT "Pressione minima [pmin>=p. ambiente] (bar)"; pmin
        IF pmin < pamb THEN test1 = 0
        LOCATE 7, 7: INPUT "Rapporto di compressione [6<=beta<=12]"; beta
        IF beta < 6 OR beta > 12 THEN test2 = 0
        LOCATE 9, 7: INPUT "Pressione intermedia [pmin<pint<pmax] (bar)"; pint
        IF pint < pmin OR pint > (pmin * beta) THEN test3 = 0
        LOCATE 11, 7: INPUT "Potenza utile (kW)"; Ptot
        IF Ptot <= 0 THEN test4 = 0
        LOCATE 19, 30: PRINT "Dati esatti (s/n)  s"
        LOCATE 19, 49: INPUT y$
    WEND
    tamb = tamb + cnck
    pmax = beta * pmin
    eta1bp = eta1bp / 100
    eta1ap = eta1ap / 100
    eta2 = eta2 / 100
    CLS
REM ****FINE ACQUISIZIONE DATI****
REM
REM ****CALCOLO PROPRIETA' AMBIENTE E COSTANTE EXERGETICA****
    samb = srif + FNEntr(tamb, trif, pamb, pamb)
    hamb = hrif + FNEntal(tamb, trif)
    Costex = hamb - tamb * samb
REM
REM ****COMPRESSORE****
    REM +++++
    REM p.to1
    REM +++++
        TEMP(1) = tmin + cnck
        PRES(1) = pmin
        ENTAL(1) = hrif + FNEntal(TEMP(1), trif)
        ENTR(1) = srif + FNEntr(TEMP(1), trif, PRES(1), pamb)
        EXER(1) = (ENTAL(1) - tamb * ENTR(1)) - Costex
    REM+++++++
    REM p.to2s : N.B. corrisponde al N.7
    REM ++++++
        PRES(7) = pmax
        REM valore di primo tentativo con cp=cost
           tk1 = TEMP(1) * beta ^ gamma
        CALL newtonDs(tk1, TEMP(1), PRES(1), PRES(7), co, t)
        IF co = 1000 THEN
           PALETTE 1, 20
           PRINT "ATTENZIONE:"
           PRINT "Dopo 1000 iterazioni il calcolo della temperatura del p.to 2s non converge"
           PRINT "Il programma usera' il valore di primo tentativo con cp=cost."
           PRINT "Premere un tasto per continuare o Q per interrompere"
           WHILE INKEY$ = "": WEND
           IF INKEY$ = "q" OR INKEY$ = "Q" THEN
                END
           END IF
           t = tk1
        END IF
        TEMP(7) = t
        ENTR(7) = FNEntr(TEMP(7), trif, PRES(7), pamb) + srif
        ENTAL(7) = FNEntal(TEMP(7), trif) + hrif
        EXER(7) = (ENTAL(7) - tamb * ENTR(7)) - Costex
    REM +++++
    REM p.to2
    REM +++++
        PRES(2) = pmax: REM =PRES(7)
        ENTAL(2) = ((ENTAL(7) - ENTAL(1)) / eta2) + ENTAL(1): REM eta2=h2s-h1/h2-h1
        REM valore di primo tentativo: cp=cost
           tk1 = ((TEMP(7) - TEMP(1)) / eta2) + TEMP(1)
        CALL newtonDh(tk1, TEMP(1), ENTAL(1), ENTAL(2), co, t)
        IF co = 1000 THEN
           PALETTE 1, 20
           PRINT "ATTENZIONE:"
           PRINT "Dopo 1000 iterazioni il calcolo della temperatura del p.to 2 non converge"
           PRINT "Il programma usera' il valore di primo tentativo con cp=cost."
           PRINT "Premere un tasto per continuare o Q per interrompere"
           WHILE INKEY$ = "": WEND
           IF INKEY$ = "q" OR INKEY$ = "Q" THEN
                END
           END IF
           t = tk1
        END IF
        TEMP(2) = t
        ENTR(2) = FNEntr(TEMP(2), trif, PRES(2), pamb) + srif
        EXER(2) = (ENTAL(2) - tamb * ENTR(2)) - Costex
REM
REM
REM ****PRIMA ADDUZIONE DI CALORE****
    ingr = 2: REM p.to di ingresso sc. calore
    CALL sccalore(tmax, TA, ingr, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM
REM
REM ****TURBINA DI ALTA PRESSIONE****
    ingt = 3: REM p.to di ingresso turbina
    CALL turbina(tmax, pmax, pint, ingt, eta1ap, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM
REM
REM ****SECONDA ADDUZIONE DI CALORE****
    ingr = 4: REM p.to di ingresso sc. calore
    CALL sccalore(tmax, TA, ingr, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
REM rendimento exergetico e difetto d'efficienza per le adduzioni di calore
REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        tau = 1 - tamb / (TA + cnck)
        COMPON(2, 2) = COMPON(2, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(2, 3) = 1 - COMPON(2, 4) / (COMPON(2, 6) * tau): REM rendim. exergetico
        COMPON(4, 2) = COMPON(4, 4) / ((COMPON(4, 6) + COMPON(2, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(4, 3) = 1 - COMPON(4, 4) / (COMPON(4, 6) * tau): REM rendim. exergetico
REM
REM
REM ****TURBINA BASSA PRESSIONE****
    ingt = 5: REM p.to di ingresso turbina
    CALL turbina(tmax, pint, pmin, ingt, eta1bp, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM
REM
REM ****BILANCI****
REM
    REM +++++++
    REM COMPRESSORE
    REM +++++++
       Ltot = ENTAL(2) - ENTAL(1)
       sgen = ENTR(2) - ENTR(1)
       exdis = (EXER(1) - EXER(2)) + Ltot
       COMPON(1, 2) = (exdis / ((COMPON(2, 6) + COMPON(4, 6)) * tau))
       COMPON(1, 1) = eta2:
       COMPON(1, 3) = 1 - exdis / Ltot: COMPON(1, 4) = exdis
       COMPON(1, 5) = sgen: COMPON(1, 6) = 0
       COMPON(1, 7) = Ltot
REM
    REM +++++++
    REM TURBINE
    REM +++++++
       COMPON(3, 1) = eta1ap: COMPON(5, 1) = eta1bp
       FOR i = 3 TO 5 STEP 2
        u = i + 1
        COMPON(i, 7) = ENTAL(i) - ENTAL(u): REM Lavoro scambiato
        COMPON(i, 5) = ENTR(u) - ENTR(i): REM Entropia generata
        COMPON(i, 4) = (EXER(i) - EXER(u)) - COMPON(i, 7): REM Exergia distrutta
        COMPON(i, 2) = COMPON(i, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM Difetto di efficienza
        COMPON(i, 3) = 1 - (COMPON(i, 4) / COMPON(i, 7)): REM Rendimento exergetico
        COMPON(i, 6) = 0: REM Calore scambiato
       NEXT i
REM
REM +++++++
    REM SOTTRAZIONE CALORE
    REM +++++++
        COMPON(6, 6) = ENTAL(6) - ENTAL(1): REM calore scambiato
        COMPON(6, 5) = ENTR(1) - ENTR(6) + (COMPON(6, 6) / (tamb)): REM sgen
        COMPON(6, 4) = (EXER(6) - EXER(1)): REM exdistr
        COMPON(6, 2) = COMPON(6, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(6, 3) = 0: REM rendim. exergetico
        COMPON(6, 1) = 1
REM
REM
REM
REM ****CALCOLO PORTATA MASSICA****
    lut = (COMPON(3, 7) + COMPON(5, 7) - COMPON(1, 7))
    m = Ptot / lut: REM Portata massica in Kg/s
REM
REM
REM ****CALCOLO PROPRIETA' DELL'IMPIANTO****
   etaimp = lut / (COMPON(2, 6) + COMPON(4, 6)): REM Rendimento energetico
   exdimp = 0: sgenimp = 0
   FOR i = 1 TO 6
        exdimp = exdimp + COMPON(i, 4): REM Exergia distrutta
        sgenimp = sgen + COMPON(i, 5): REM Entropia generata
   NEXT i
   deltaimp = (exdimp) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM difetto di efficienza
   etaeximp = 1 - deltaimp: REM Rendimento exergetico
   exdimp = exdimp * m
   sgenimp = sgenimp * m
REM
REM ****SALVATAGGIO VALORI PROPRIETA'****
   FOR i = 1 TO 6
        FOR j = 1 TO 7
            COMP2(i, j) = COMPON(i, j)
        NEXT j
        PROP(1, i) = TEMP(i): PROP(2, i) = PRES(i): PROP(3, i) = ENTR(i)
        PROP(4, i) = ENTAL(i): PROP(5, i) = EXER(i)
   NEXT i
REM
REM ****CALCOLO P. INTERMEDIA OTTIMALE****
   CALL pott(eta1ap, eta1bp, eta2, TA, tmax, tmin, beta, pmin, mak(), Ptot, risul, pot, COMPON(), TEMP(), PRES(), ENTR(), ENTAL(), EXER())
REM
REM ****RIPRISTINO VALORI PROPRIETA' E TRASF. IN GRANDEZZE ESTENSIVE****
   FOR i = 1 TO 6
        FOR j = 1 TO 7
            COMPON(i, j) = COMP2(i, j)
        NEXT j
        FOR j = 4 TO 7
            COMPON(i, j) = COMPON(i, j) * m
        NEXT j
        TEMP(i) = PROP(1, i): PRES(i) = PROP(2, i): ENTR(i) = PROP(3, i)
        ENTAL(i) = PROP(4, i): EXER(i) = PROP(5, i)
   NEXT i
REM
REM ****TABELLE****
REM
REM
10  CLS
    sc = 5
    LOCATE 2, 27: PRINT "SCELTA SCHERMATA DI OUTPUT"
    LOCATE 6, 20: PRINT "1 - Propriet punti del ciclo"
    LOCATE 8, 20: PRINT "2 - Propriet componenti"
    LOCATE 10, 20: PRINT "3 - Propriet impianto"
    LOCATE 12, 20: PRINT "4 - Modifica dati di input"
    LOCATE 14, 20: PRINT "0 - FINE"
    WHILE sc <> 0 AND sc <> 1 AND sc <> 2 AND sc <> 3 AND sc <> 4
    LOCATE 22, 20: INPUT "Selezionare un numero"; sc
    WEND
    IF sc = 0 THEN END
    ON sc GOTO 100, 200, 300, 400
100 CLS
    PRINT : PRINT
    PRINT SPACE$(21); "TABELLA PROPRIETA' DEI PUNTI DEL CICLO"
    PRINT
    PRINT SPACE$(15); "P.to   temp.     pres.    ental.     entr.    exer. "
    PRINT SPACE$(15); "       (C)      (bar)   (kJ/kg)   (kJ/kgK)  (kJ/kg)"
    PRINT
    FOR i = 1 TO 6
        PRINT SPACE$(15); USING "#     ####.##   ###.##   ####.##    ##.##   ####.##"; i; TEMP(i) - cnck; PRES(i); ENTAL(i); ENTR(i); EXER(i)
    NEXT i
    DRAW "BM 200,345 M+0,-40 M+10,10 M+0,20 M-10,10"
    DRAW "BM 210,315 M+0,-40 M+30,0 M+10,-10 M+20,20 M+10,-10 M+30,0"
    DRAW "BM 310,275 M+0,40 M+0,20 M+10,10 M+0,-40 M-10,10"
    DRAW "BM 320,305 M+0,-30 M+30,0 M+10,-10 M+20,20 M+10,-10 M+30,0"
    DRAW "BM 420,275 M+0,40 M+0,20 M+10,10 M+0,-40 M-10,10"
    DRAW "BM 430,345 M+0,30 M-95,0 M-10,10 M-20,-20 M-10,10 M-95,0 M+0,-30"
    DRAW "BM 210,328 M+100,0 BM 210,322 M+100,0"
    DRAW "BM 320,328 M+100,0 BM 320,322 M+100,0"
    DRAW "BM 430,328 M+15,0 BM 430,322 M+15,0"
    CIRCLE (460, 325), 15
    LINE (235, 260)-(285, 290), , B: LINE (345, 260)-(395, 290), , B
    LINE (290, 360)-(340, 390), , B
    DRAW "BM 207,295 M+6,0 BM 307,295 M+6,0 BM 317,295 M+6,0 BM 417,295 M+6,0"
    DRAW "BM 197,365 M+6,0 BM 427,365 M+6,0"
    LOCATE 21, 58: PRINT "G"
    LOCATE 23, 24: PRINT "1": LOCATE 19, 25: PRINT "2"
    LOCATE 19, 38: PRINT "3": LOCATE 19, 42: PRINT "4"
    LOCATE 19, 55: PRINT "5": LOCATE 23, 56: PRINT "6"
    LOCATE 16, 31: PRINT "SET A": LOCATE 16, 45: PRINT "SET A"
    LOCATE 26, 38: PRINT "SET B"
    LOCATE 29, 1: PRINT "Premere un tasto per continuare"
    WHILE INKEY$ = "": WEND
    sc = 5: GOTO 10
200 CLS
    PRINT : PRINT
    PRINT SPACE$(22); "TABELLA DEI COMPONENTI DELL'IMPIANTO"
    PRINT
    PRINT SPACE$(16); "ETAis  delta   ETAex   EXdis   Sgen      Q         L"
    PRINT SPACE$(16); "                       (kW)   (kW/K)    (kW)      (kW)"
    PRINT
    FOR j = 1 TO 6
        PRINT SPACE$(16); USING "#.##   #.##    #.##  #####.##  ##.##  #####.#   #####.#"; COMPON(j, 1); COMPON(j, 2); COMPON(j, 3); COMPON(j, 4); COMPON(j, 5); COMPON(j, 6); COMPON(j, 7)
        PRINT
    NEXT j
    LOCATE 8, 1: PRINT "Compressore": LOCATE 8, 55: PRINT "   -   "
    LOCATE 10, 1: PRINT "I sc. calore     -   ": LOCATE 10, 66: PRINT "  -   "
    LOCATE 12, 1: PRINT "Turbina a.p.": LOCATE 12, 55: PRINT "   -   "
    LOCATE 14, 1: PRINT "II sc. calore    -   ": : LOCATE 14, 66: PRINT "  -   "
    LOCATE 16, 1: PRINT "Turbina b.p.": LOCATE 16, 55: PRINT "   -   "
    LOCATE 18, 1: PRINT "III sc. calore   -  ": LOCATE 18, 31: PRINT "  -  "
    LOCATE 18, 66: PRINT "  -   "
    LOCATE 21, 1: PRINT "Portata massica (kg/s) = "; USING "###.##"; m
    LOCATE 27, 1: PRINT "Premere un tasto per continuare"
    WHILE INKEY$ = "": WEND
    sc = 5: GOTO 10
300 CLS
    LOCATE 2, 31: PRINT "DATI DELL'IMPIANTO"
    LOCATE 5, 15: PRINT "Exergia distrutta (kW)  = "; USING "#####.#"; exdimp
    LOCATE 7, 15: PRINT "Rendimento exergetico = "; USING "#.##"; etaeximp
    LOCATE 9, 15: PRINT "Difetto di efficienza = "; USING "#.##"; deltaimp
    LOCATE 11, 15: PRINT "Entropia generata (kW/K) = "; USING "###.##"; sgenimp
    LOCATE 13, 15: PRINT "Rendimento energetico = "; USING "#.##"; etaimp
    LOCATE 15, 15: PRINT "Rendimento di Carnot = "; USING "#.##"; (1 - (tmin + cnck) / (tmax + cnck))
    LOCATE 17, 15: PRINT "Potenza termica fornita (kW) = "; USING "#####.#"; COMPON(2, 6) + COMPON(4, 6)
    LOCATE 19, 28: PRINT "--------------"
    LOCATE 21, 10: PRINT "In questa versione non  previsto il calcolo della p. int. ottimale"
    LOCATE 22, 10: PRINT "I dati relativi alle varie p. int. sono salvati nel file dati.txt"
'    LOCATE 21, 15: PRINT "Pressione intermedia ottimale (bar) = "; USING "###.#"; pot
'    LOCATE 23, 15: PRINT "Rend. en. max ottenuto con p. int. ottimale = "; USING "#.##"; risul
    LOCATE 27, 1: PRINT "Premere un tasto per continuare"
    WHILE INKEY$ = "": WEND
    sc = 5: GOTO 10
400 CLEAR : st = 4: GOTO 1

SUB newtonDh (t1tent!, tiniz!, h1, h2, co, tusc!)
    co = 0
    tki = t1tent!: ty = tiniz!
    fun = FNEntal(tki, ty) - (h2 - h1)
    DO UNTIL ABS(fun) < eps OR co = 1000
        der = a + B * tki + c * tki ^ 2 + d * tki ^ 3
        tki = tki - fun / der
        fun = FNEntal(tki, ty) - (h2 - h1)
        co = co + 1
    LOOP
    tusc! = tki
END SUB

SUB newtonDs (t1tent!, tiniz!, p1, p2, co, tusc!)
    co = 0
    tki = t1tent!: ty = tiniz!
    fun = FNEntr(tki, ty, p2, p1)
    DO UNTIL ABS(fun) < eps OR co = 1000
        der = a / tki + B + c * tki + d * tki ^ 2
        tki = tki - fun / der: REM x(i+1)=x(i)-f(x)/f'(x)
        fun = FNEntr(tki, ty, p2, p1)
        co = co + 1
    LOOP
    tusc! = tki
END SUB

SUB pott (eta1ap, eta1bp, eta2, TA, tmax, tmin, beta, pmin, mak(), Ptot, risul, pot, COMPON(), TEMP(), PRES(), ENTR(), ENTAL(), EXER())
pmax = beta * pmin
st = (pmax - pmin) / 50: REM Suddivisione intervallo
FOR k = pmin + st TO pmax - st STEP st
pint = k
REM
REM ****TURBINA DI ALTA PRESSIONE****
    ingt = 3: REM p.to di ingresso turbina
    CALL turbina(tmax, pmax, pint, ingt, eta1ap, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM
REM
REM ****SECONDA ADDUZIONE DI CALORE****
    ingr = 4: REM p.to di ingresso sc. calore
    CALL sccalore(tmax, TA, ingr, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
REM rendimento exergetico e difetto d'efficienza per le adduzioni di calore
REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        tau = 1 - tamb / (TA + cnck)
        COMPON(2, 2) = COMPON(2, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(2, 3) = 1 - COMPON(2, 4) / (COMPON(2, 6) * tau): REM rendim. exergetico
        COMPON(4, 2) = COMPON(4, 4) / ((COMPON(4, 6) + COMPON(2, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(4, 3) = 1 - COMPON(4, 4) / (COMPON(4, 6) * tau): REM rendim. exergetico
REM
REM
REM ****TURBINA BASSA PRESSIONE****
    ingt = 5: REM p.to di ingresso turbina
    CALL turbina(tmax, pint, pmin, ingt, eta1bp, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())

REM
REM
REM ****SOTTRAZIONE DI CALORE****
    REM +++++++
    REM bilanci
    REM +++++++
        COMPON(6, 6) = ENTAL(6) - ENTAL(1): REM calore scambiato
        COMPON(6, 5) = ENTR(1) - ENTR(6) + (COMPON(6, 6) / (tamb)): REM sgen
        COMPON(6, 4) = (EXER(6) - EXER(1)): REM exdistr
        COMPON(6, 2) = COMPON(6, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM difetto di efficienza=exdist/q*tau
        COMPON(6, 3) = 1 - COMPON(6, 2): REM rendim. exergetico
        COMPON(6, 1) = 1
REM
REM ***BILANCI***
REM
    REM +++++++
    REM COMPRESSORE
    REM +++++++
       Ltot = ENTAL(2) - ENTAL(1)
       sgen = ENTR(2) - ENTR(1)
       exdis = (EXER(1) - EXER(2)) + Ltot
       COMPON(1, 2) = (exdis / ((COMPON(2, 6) + COMPON(4, 6)) * tau))
       COMPON(1, 1) = eta2:
       COMPON(1, 3) = 1 - exdis / Ltot: COMPON(1, 4) = exdis
       COMPON(1, 5) = sgen: COMPON(1, 6) = 0
       COMPON(1, 7) = Ltot
REM
    REM +++++++
    REM TURBINE
    REM +++++++
       COMPON(3, 1) = eta1ap: COMPON(5, 1) = eta1bp
       FOR i = 3 TO 5 STEP 2
        u = i + 1
        COMPON(i, 7) = ENTAL(i) - ENTAL(u): REM Lavoro scambiato
        COMPON(i, 5) = ENTR(u) - ENTR(i): REM Entropia generata
        COMPON(i, 4) = (EXER(i) - EXER(u)) - COMPON(i, 7): REM Exergia distrutta
        COMPON(i, 2) = COMPON(i, 4) / ((COMPON(2, 6) + COMPON(4, 6)) * tau): REM Difetto di efficienza
        COMPON(i, 3) = 1 - (COMPON(i, 4) / COMPON(i, 7)): REM Rendimento exergetico
        COMPON(i, 6) = 0: REM Calore scambiato
       NEXT i

REM
REM ****CALCOLO PORTATA MASSICA****
    lut = (COMPON(3, 7) + COMPON(5, 7) - COMPON(1, 7))
    m = Ptot / lut: REM Portata massica in Kg/s
REM
REM
REM ****CALCOLO PROPRIETA' DELL'IMPIANTO****
   etaimp = lut / (COMPON(2, 6) + COMPON(4, 6)): REM Rendimento energetico
mak(1, k) = lut
mak(2, k) = etaimp
NEXT k
OPEN "dati.txt" FOR OUTPUT AS #1: REM salvataggio dati
FOR k = pmin TO pmax STEP st
    PRINT #1, USING "##.###   ####.###   #.###"; k; mak(1, k); mak(2, k)
NEXT k
CLOSE #1
END SUB

SUB sccalore (t2!, Tset!, ingr, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
    REM +++++++++++
    REM p.to uscita
    REM +++++++++++
        usc = ingr + 1
        tku = t2! + cnck
        ENTAL(usc) = FNEntal(tku, trif) + hrif
        ENTR(usc) = FNEntr(tku, trif, PRES(ingr), pamb) + srif
        EXER(usc) = (ENTAL(usc) - tamb * ENTR(usc)) - Costex
        PRES(usc) = PRES(ingr): TEMP(usc) = tku
    REM +++++++
    REM bilanci
    REM +++++++
        COMPON(ingr, 6) = ENTAL(usc) - ENTAL(ingr): REM calore scambiato
        COMPON(ingr, 5) = ENTR(usc) - ENTR(ingr) - (COMPON(ingr, 6) / (Tset! + cnck)): REM sgen
        tau = 1! - (tamb / (Tset! + cnck))
        COMPON(ingr, 4) = (EXER(ingr) - EXER(usc)) + (COMPON(ingr, 6) * tau): REM exdistr
        COMPON(ingr, 1) = 1
END SUB

SUB turbina (ting!, ping!, pusc!, ingt, rend!, TEMP(), PRES(), ENTAL(), ENTR(), EXER(), COMPON())
    usct = ingt + 1
    REM +++++
    REM p.to1 : N.B. corrisponde al p.to in ingresso nella turbina
    REM +++++
        t1 = ting! + cnck
        p1 = ping!
    REM+++++++
    REM p.to2s : N.B. corrisponde al p.to di uscita ideale dalla turbina
    REM ++++++
        PRES(usct) = pusc!
        REM valore di primo tentativo con cp=cost
           tk1 = t1 * (pusc! / ping!) ^ gamma
        CALL newtonDs(tk1, t1, p1, PRES(usct), co, t)
        IF co = 1000 THEN
           PALETTE 1, 20
           PRINT "ATTENZIONE:"
           PRINT "Dopo 1000 iterazioni il calcolo della temperatura del p.to di uscita ideale"
           PRINT "dalla turbina non converge"
           PRINT "Il programma usera' il valore di primo tentativo con cp=cost."
           PRINT "Premere un tasto per continuare o Q per interrompere"
           WHILE INKEY$ = "": WEND
           IF INKEY$ = "q" OR INKEY$ = "Q" THEN
                END
           END IF
           t = tk1
        END IF
        Tks = t
        s = FNEntr(Tks, trif, PRES(usct), pamb) + srif
        hs = FNEntal(Tks, trif) + hrif
        exs = (hs - tamb * s) - Costex
    REM +++++
    REM p.to2 N.B. corrisponde al p.to di uscita reale dalla turbina
    REM +++++
        ENTAL(usct) = ((hs - ENTAL(ingt)) * rend!) + ENTAL(ingt): REM eta=h2-h1/h2s-h1
        REM valore di primo tentativo: cp=cost
           tk1 = ((Tks - TEMP(ingt)) * rend!) + TEMP(ingt)
        CALL newtonDh(tk1, TEMP(ingt), ENTAL(ingt), ENTAL(usct), co, t)
        IF co = 1000 THEN
           PALETTE 1, 20
           PRINT "ATTENZIONE:"
           PRINT "Dopo 1000 iterazioni il calcolo della temperatura del p.to di uscita reale"
           PRINT "dalla turbina non converge"
           t = tk1
           PRINT "Premere un tasto per continuare o Q per interrompere"
           WHILE INKEY$ = "": WEND
           IF INKEY$ = "q" OR INKEY$ = "Q" THEN
                END
           END IF
        END IF
        TEMP(usct) = t
        ENTR(usct) = FNEntr(TEMP(usct), trif, PRES(usct), pamb) + srif
        EXER(usct) = (ENTAL(usct) - tamb * ENTR(usct)) - Costex
END SUB

